﻿namespace EVCB_OCPP.Packet20.DataTypes.EnumTypes
{
    public enum ChargingStateEnumType
    {
        /// <summary>
        /// The contactor of the Connector is closed and energy is flowing to between EVSE and EV.
        /// </summary>
        Charging = 1,
        /// <summary>
        /// There is a connection between EV and EVSE, in case the protocol used between EV and the Charging Station
        /// can detect a connection, the protocol needs to detect this for the state to become active. The connection
        ///can either be wired or wireless.
        /// </summary>
        EVConnected,
        /// <summary>
        /// When the EV is connected to the EVSE and the EVSE is offering energy but the EV is not taking any energy.
        /// </summary>
        SuspendedEV,
        /// <summary>
        /// When the EV is connected to the EVSE but the EVSE is not offering energy to the EV, e.g. due to a smart
        /// charging restriction, local supply power constraints, or when charging has stopped because of the
        ///authorization status in the response to a transactionEventRequest indicating that charging is not allowed
        ///etc.
        /// </summary>
        SuspendedEVSE,
        /// <summary>
        /// There is no connection between EV and EVSE.
        /// </summary>
        Idle
    }
}
