﻿using Newtonsoft.Json;

namespace EVCB_OCPP.Packet20.DataTypes.EnumTypes
{
    public enum DataEnumType
    {

        /// <summary>
        ///  This variable is of the type string.
        /// </summary>
        [JsonProperty("string")]
        _string,
        /// <summary>
        ///  This variable is of the type decimal.
        /// </summary>
        [JsonProperty("decimal")]
        _decimal,
        /// <summary>
        ///  This variable is of the type integer.
        /// </summary>
        integer,
        /// <summary>
        ///  DateTime following the [RFC3339] specification.
        /// </summary>
        dateTime,
        /// <summary>
        ///  This variable is of the type boolean.
        /// </summary>
        boolean,
        /// <summary>
        ///  Supported/allowed values for a single choice, enumerated, text variable.
        /// </summary>
        OptionList,
        /// <summary>
        ///  Supported/allowed values for an ordered sequence variable.
        /// </summary>
        SequenceList,
        /// <summary>
        ///  Supported/allowed values for a mathematical set variable.
        /// </summary>
        MemberList

    }
}
