﻿namespace EVCB_OCPP.Packet20.DataTypes.EnumTypes
{
    public enum MonitorEnumType
    {
        /// <summary>
        /// Triggers an event notice when the actual value of the Variable rises above monitorValue
        /// </summary>
        UpperThreshold = 1,
        /// <summary>
        ///  Triggers an event notice when the actual value of the Variable drops below monitorValue.
        /// </summary>
        LowerThreshold,
        /// <summary>
        ///  Triggers an event notice when the actual value has changed more than plus or minus monitorValue since the
        /// time that this monitor was set or since the last time this event notice was sent, whichever was last. For
        ////boolean variables, use monitorValue = 1 to trigger an event notice whenever the boolean value toggles from
        ////0 to 1 or vice versa.
        /// </summary>
        Delta,
        /// <summary>
        ///  Triggers an event notice every monitorValue seconds interval, starting from the time that this monitor was
        ///set.
        /// </summary>
        Periodic,
        /// <summary>
        /// Triggers an event notice every monitorValue seconds interval, starting from the nearest clock-aligned interval
        /// after this monitor was set. For example, a monitorValue of 900 will trigger event notices at 0, 15, 30 and 45
        ///minutes after the hour, every hour.
        /// </summary>
        PeriodicClockAligned

    }
}
