﻿namespace EVCB_OCPP.Packet20.DataTypes.EnumTypes
{
    public enum UploadLogStatusEnumType
    {
        /// <summary>
        ///  A badly formatted packet or other protocol incompatibility was detected.
        /// </summary>
        BadMessage = 1,
        /// <summary>
        ///  The Charging Station is not uploading a log file. Idle SHALL only be used when the message was triggered by
        ///  a TriggerMessageRequest.
        /// </summary>
        Idle,
        /// <summary>
        /// The server does not support the operation
        /// </summary>
        NotSupportedOperation,
        /// <summary>
        ///  Insufficient permissions to perform the operation.
        /// </summary>
        PermissionDenied,
        /// <summary>
        ///  File has been uploaded successfully.
        /// </summary>
        Uploaded,
        /// <summary>
        ///  Failed to upload the requested file.
        /// </summary>
        UploadFailure,
        /// <summary>
        ///  File is being uploaded.
        /// </summary>
        Uploading
    }
}
