﻿using EVCB_OCPP.Packet20.DataTypes.EnumTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet20.DataTypes
{
    public class GroupIdTokenType
    {
        /// <summary>
        /// IdToken is case insensitive. Might hold the
        ///  hidden id of an RFID tag, but can for example also
        ///contain a UUID.
        /// </summary>
        [Required]
        [StringLength(36, MinimumLength = 0)]
        public string IdToken { set; get; }

        /// <summary>
        /// Enumeration of possible idToken types.
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public IdTokenEnumType Type { set; get; }
    }
}
