﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet20.DataTypes
{
    public class ReportDataType
    {
        /// <summary>
        /// Component for which a report of Variable is
       /// requested.
                /// </summary>
        [Required]
        public ComponentType Component { set; get; }

        /// <summary>
        /// Variable for which report is requested
        /// </summary>
        [Required]
        public VariableType variable { set; get; }

        /// <summary>
        /// Attribute data of a variable.
        /// </summary>
        [Required]
        public List<VariableAttributeType> VariableAttribute { set; get; }

        /// <summary>
        /// Fixed read-only parameters of a variable.
        /// </summary>    
        public VariableCharacteristicsType VariableCharacteristics { set; get; }
    }
}
