﻿using EVCB_OCPP.Packet20.DataTypes.EnumTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using NJsonSchema;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet20.Messages
{
    public class GetDisplayMessagesRequest
    {
        /// <summary>
        /// If provided the Charging Station shall return
        /// Display Messages of the given ids.This field SHALL NOT
        ///  contain more ids than set in
        /// NumberOfDisplayMessages.maxLimit
        /// </summary>
        public List<int> Id { set; get; }

        /// <summary>
        /// The Id of this request
        /// </summary>
        [Required]
        public int RequestId { set; get; }

        /// <summary>
        /// If provided the Charging Station shall return
        ///Display Messages with the given priority only
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MessagePriorityEnumType Priority { set; get; }

        /// <summary>
        /// If provided the Charging Station shall return
        /// Display Messages with the given state only.
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MessageStateEnumType State { set; get; }



    }
}
