﻿using EVCB_OCPP.Packet20.DataTypes.EnumTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet20.Messages
{
    public class GetLogResponse
    {
        /// <summary>
        /// This field indicates whether the Charging
        ///Station was able to accept the request
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public LogStatusEnumType Status { set; get; }

        /// <summary>
        /// This contains the name of the log file that will
        ///  be uploaded.This field is not present when no logging
        /// information is available.
        /// </summary>
        [StringLength(255, MinimumLength = 0)]
        public string FileName { set; get; }
    }
}
