﻿using EVCB_OCPP.Packet20.DataTypes.EnumTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet20.Messages
{
    public class ResetRequest
    {
        /// <summary>
        /// This contains the type of reset that the
        ///Charging Station or EVSE should perform
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public ResetEnumType Type { set; get; }

        /// <summary>
        /// This contains the ID of a specific EVSE that
        ///needs to be reset, instead of the entire Charging Station.
        /// </summary>
        public int? EvseId { set; get; }
    }
}
